//+------------------------------------------------------------------+
//|                                          Gann high-low activator |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Black
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;   // Time frame
extern string             ForSymbol        = "";               // For symbol (empty for current chart symbol)
extern double             Phase            = 0;                // Smoothing phase
extern int                mode             = 1;                // Hilbert transform mode (1 to 3)
extern ENUM_APPLIED_PRICE price            = PRICE_MEDIAN;     // Price
extern int                smooth           = 5;                // Smoothing period
extern bool               alertsOn         = true;            // Turn alerts on?
extern bool               alertsOnCurrent  = false;             // Alerts on current (stil opened) bar?
extern bool               alertsMessage    = true;             // Alerts should display message?
extern bool               alertsSound      = true;            // Alerts should play alerting sound?
extern bool               alertsEmail      = false;            // Alerts should sens an email?
extern bool               ShowArrows       = false;            // Arrows visible?
extern double             arrowsDistance   = 0.5;              // Arrows gap from high or low price (in ATR)
extern string             arrowsIdentifier = "ganhlhsArrows";  // Arrows unique ID
extern color              arrowsUpColor    = clrDodgerBlue;   // Color for up arrow
extern color              arrowsDnColor    = clrHotPink;       // Color for down arrow
extern int                arrowsUpCode     = 233;              // Up arrow code (default 241)
extern int                arrowsDnCode     = 234;              // Down arrow code (default 242)
extern int                arrowsSize       = 2;                // Arrows size

//
//
//
//
//

double gup[];
double gdn[];
double trend[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,gup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,gdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   
      mode      = MathMax(MathMin(mode,3),1);
      ForSymbol = StringTrimLeft(StringTrimLeft(ForSymbol));
         if (StringLen(ForSymbol) == 0) ForSymbol = _Symbol;
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" "+ForSymbol+" Gann high/low activator - HeikenAshi");
   return(0);
}
int deinit()
{
   if (ShowArrows) deleteArrows();
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define haClose 0
#define haOpen  1
#define haHigh  2
#define haLow   3

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { gup[0] = limit+1; return(0); }
           if (TimeFrame!=_Period || ForSymbol!=_Symbol)
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               for(i=limit; i>=0; i--)
               {
                  int y = iBarShift(ForSymbol,TimeFrame,Time[i]);
                     trend[i] = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",Phase,mode,price,smooth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
                     gup[i]   = EMPTY_VALUE;
                     gdn[i]   = EMPTY_VALUE;
                        if (trend[i] ==  1) gup[i] = 1;
                        if (trend[i] == -1) gdn[i] = 1;
                        manageArrow(i);
               }
               return(0);
            }               

   //
   //
   //
   //
   //

      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      for(i=limit, r=Bars-i-1;i>=0;i--,r++)
      {
         if (r==0)
         {
            work[r][haOpen]  = (Open[i]+Close[i])/2.0;
            work[r][haClose] = (Open[i]+Close[i]+High[i]+Low[i])/4.0;
            work[r][haHigh]  = High[i];
            work[r][haLow]   = Low[i];
            continue;
         }
         
         //
         //
         //
         //
         //
            double Length  = MathMax(iHilbert(iMA(NULL,0,1,0,MODE_SMA,price,i),mode,smooth,i)/2,1);
            double maOpen  = iSmooth(Open[i], Length,Phase,i, 0);
            double maClose = iSmooth(Close[i],Length,Phase,i,10);
            double maLow   = iSmooth(Low[i],  Length,Phase,i,20);
            double maHigh  = iSmooth(High[i], Length,Phase,i,30);

            //
            //
            //
            //
            //
               
               work[r][haOpen]  = (work[r-1][haOpen]+work[r-1][haClose])/2.0;
               work[r][haClose] = (maOpen+maHigh+maLow+maClose)/4.0;
               work[r][haHigh]  = MathMax(maHigh,MathMax(work[r][haOpen],work[r][haClose]));
               work[r][haLow]   = MathMin(maLow ,MathMin(work[r][haOpen],work[r][haClose]));

            //
            //
            //
            //

               gup[i] = EMPTY_VALUE;
               gdn[i] = EMPTY_VALUE;
               trend[i] = trend[i+1];
                  if(Close[i]>work[r-1][haHigh]) trend[i] =  1;
                  if(Close[i]<work[r-1][haLow] ) trend[i] = -1;
                  if(trend[i] == -1)
                        gdn[i] = 1;
                  else  gup[i] = 1;
                  manageArrow(i);
      }
      return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows && i<Bars-1)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = arrowsDistance*iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,arrowsSize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+(string)time; ObjectDelete(lookFor);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Gann HL activator trend changed to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Gann HL "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double tprice, double length, double phase, int i, int s=0)
{
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int k,r = Bars-i-1; 
      if (r==0) { for(k=0; k<7; k++) wrk[0][k+s]= tprice; for(; k<10; k++) wrk[0][k+s]= 0; return(price); }

   //
   //
   //
   //
   //
   
      double len1 = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1 = MathMax(len1-2.0,0.5);
      double del1 = tprice - wrk[r-1][bsmax+s];
      double del2 = tprice - wrk[r-1][bsmin+s];
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[(int)MathMax(r-1,0)][vsum+s] + 0.1*(wrk[r][volty+s]-wrk[(int)MathMax(r-10,0)][volty+s]);
   
         //
         //
         //
         //
         //
      
         double avg,avgLen = MathMin(MathMax(4.0*length,30),150);
            if (r<avgLen)
            {
               avg = wrk[r][vsum+s];  for (k=1; k<avgLen && (r-k)>=0 ; k++) avg += wrk[r-k][vsum+s];
                                                                            avg /= k;
            }
            else avg = (wrk[(int)MathMax(r-1,0)][avolty+s]*avgLen-wrk[(int)MathMax(r-toInt(avgLen),0)][vsum+s]+wrk[r][vsum+s])/avgLen;
            
         //
         //
         //
         //
         //
                                                           
         wrk[r][avolty+s] = avg; double dVolty = 0;
            if (wrk[r][avolty+s] > 0)   dVolty = wrk[r][volty+s]/wrk[r][avolty+s];
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));		
	
         if (del1 > 0) wrk[r][bsmax+s] = tprice; else wrk[r][bsmax+s] = tprice - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = tprice; else wrk[r][bsmin+s] = tprice - Kv*del2;

   //
   //
   //
   //
   //

      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = tprice + alpha*(wrk[r-1][0+s]-tprice);
         wrk[r][1+s] = (tprice - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}
int toInt(double value) { return((int)value); }   


double workHil[][13];
#define _price     0
#define _smooth    1
#define _detrender 2
#define _period    3
#define _Q1        4
#define _I1        5
#define _JI        6
#define _JQ        7
#define _Q2        8
#define _I2        9
#define _Re       10
#define _Im       11
#define _res      12

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbert(double tprice, int tmode, double tsmooth, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*13;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]     = tprice; if (r<=4) { workHil[r][s+_smooth] = tprice; for (int k=2; k<12; k++) workHil[r][s+k]=0; return(0); }
      workHil[r][s+_smooth]    = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender] = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]        = calcComp(r,_detrender,s);
      workHil[r][s+_I1]        = workHil[r-3][s+_detrender];
      workHil[r][s+_JI]        = calcComp(r,_I1,s);
      workHil[r][s+_JQ]        = calcComp(r,_Q1,s);

      workHil[r][s+_I2]        = 0.2*(workHil[r][s+_I1]-workHil[r][s+_JQ])                                         + 0.8*workHil[r-1][s+_I2];
      workHil[r][s+_Q2]        = 0.2*(workHil[r][s+_Q1]+workHil[r][s+_JI])                                         + 0.8*workHil[r-1][s+_Q2];
      workHil[r][s+_Re]        = 0.2*(workHil[r][s+_I2]*workHil[r-1][s+_I2]+workHil[r][s+_Q2]*workHil[r-1][s+_Q2]) + 0.8*workHil[r-1][s+_Re];
      workHil[r][s+_Im]        = 0.2*(workHil[r][s+_I2]*workHil[r-1][s+_Q2]-workHil[r][s+_Q2]*workHil[r-1][s+_I2]) + 0.8*workHil[r-1][s+_Im];

      if (workHil[r][s+_Re]!= 0 && workHil[r][s+_Im]!=0) 
          workHil[r][s+_period] = 2.0*Pi/(MathArctan(workHil[r][s+_Im]/workHil[r][s+_Re]));
          workHil[r][s+_period] = MathMin(workHil[r][s+_period],1.50*workHil[r-1][s+_period]);
          workHil[r][s+_period] = MathMax(workHil[r][s+_period],0.67*workHil[r-1][s+_period]);
          workHil[r][s+_period] = MathMin(MathMax(workHil[r][s+_period],6),50);
          workHil[r][s+_period] = 0.2*workHil[r][s+_period]+0.8*workHil[r-1][s+_period];

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+MathMax(tsmooth,1));
   switch (tmode)
   {
      case 1 : 
            workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(workHil[r][s+_period]-workHil[r-1][s+_res]);
            break;
            
      //
      //
      //
      //
      //
                  
      case 2 :
         {
            double damp = MathSqrt(workHil[r][s+_Re]*workHil[r][s+_Re] + workHil[r][s+_Im]*workHil[r][s+_Im])/Point;
                                   workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(damp-workHil[r-1][s+_res]); 
            break;
         }            
            
      //
      //
      //
      //
      //
                  
      case 3 : 
         {
            double phase;
               if (workHil[r][s+_I1] != 0.0) 
                     phase = 180.0/Pi*MathArctan(workHil[r][s+_Q1]/workHil[r][s+_I1]);
               else  phase = 180.0;
            workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(phase-workHil[r-1][s+_res]);
            break;
         }            
   }         
   return (workHil[r][s+_res]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[(int)MathMax(r-2,0)][s+from] - 
           0.5769*workHil[(int)MathMax(r-4,0)][s+from] - 
           0.0962*workHil[(int)MathMax(r-6,0)][s+from]) * (0.075*workHil[(int)MathMax(r-1,0)][s+_period] + 0.54));
}